#ifndef HAL_LIB_H
#define HAL_LIB_H
/* Use these for x86 machines, and anything else that can write to
   individual bytes in a machine word. */
#include <linux/types.h>
#ifdef __cplusplus
typedef bool hal_bool;
#else
typedef _Bool hal_bool;
#endif
typedef volatile hal_bool hal_bit_t;
typedef volatile __u32 hal_u32_t;
typedef volatile __s32 hal_s32_t;
typedef double real_t __attribute__((aligned(8)));
typedef __u64 ireal_t __attribute__((aligned(8))); // integral type as wide as real_t / hal_float_t
#define hal_float_t volatile real_t

#ifdef __cplusplus
extern "C" {
#endif
//复位，只执行一次
void hal_reset(void);

//启动
int hal_init(void);
//退出
void hal_exit(void);
int hal_get_malloc(void **ptr, char *name, int size);
int hal_export_pin(char * name, void *ptr);
int hal_get_pin(char * name, void **ptr);
#ifdef __cplusplus
}
#endif
#endif // HAL_LIB_H
